<?php

/**
 * JulioReis_CorreiosFollowup
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @category  JulioReis
 * @package   JulioReis_CorreiosFollowup
 *
 * @copyright Copyright (c) 2018 Julio Reis (www.rapidets.com.br)
 *
 * @author    Julio Reis <julioreis.si@gmail.com>
 */

namespace JulioReis\CorreiosFollowup\Model\Mail\Template;

use Magento\Framework\Mail\MessageInterface;

class TransportBuilderByStore extends \Magento\Framework\Mail\Template\TransportBuilderByStore
{
    /** @var MessageInterface */
    protected $message;

    /** @var SenderResolverInterface */
    protected $senderResolver;

    /** @var MessageInterfaceFactory|\Magento\Framework\Mail\MessageInterfaceFactory */
    protected $messageInterfaceFactory;

    /**
     * TransportBuilderByStore constructor.
     * @param MessageInterface $message
     * @param \Magento\Framework\Mail\Template\SenderResolverInterface $senderResolver
     * @param \Magento\Framework\Mail\MessageInterfaceFactory $messageInterfaceFactory
     */
    public function __construct(
        MessageInterface $message,
        \Magento\Framework\Mail\Template\SenderResolverInterface $senderResolver,
        \Magento\Framework\Mail\MessageInterfaceFactory $messageInterfaceFactory
    ) {
        $this->message = $message;
        $this->senderResolver = $senderResolver;
        $this->messageInterfaceFactory = $messageInterfaceFactory;
    }

    /**
     * @param array|string $from
     * @param int|string $store
     * @return $this
     */
    public function setFromByStore($from, $store)
    {
        $result = $this->senderResolver->resolve($from, $store);
        $this->message->setFrom($result['email'], $result['name']);
        $this->resetMessage();
        return $this;
    }

    /**
     * @return $this
     */
    private function resetMessage()
    {
        $this->message = $this->messageInterfaceFactory->create();
        return $this;
    }
}
